No puede seleccionar más de 25 temas Los temas deben comenzar con una letra o número, pueden incluir guiones ('-') y pueden tener hasta 35 caracteres de largo.
 
 
 
 
 
 

1288 líneas
30 KiB

  1. #!/bin/sh
  2. expr "$-" : '^.*i' >/dev/null || return
  3. ##########################################
  4. null(){
  5. "$@" >/dev/null 2>&1
  6. }
  7. __safe_run(){
  8. type $1 >/dev/null 2>&1 && "$@"
  9. }
  10. __match(){
  11. # __match str word
  12. # return 0 if word is found in str
  13. expr "$1" : ".*$2.*" >/dev/null
  14. }
  15. #################################
  16. # profile-like setups
  17. # aliases:
  18. # isinteractive: true if the current session is interactive
  19. # issourced: true if this file is sourced from another file (not so assured)
  20. # __firstload: true if this file is sourced for the first time (not so
  21. # assured)
  22. __safe_add_path_r(){
  23. test -d "$1" && PATH="${PATH}:$1"
  24. }
  25. __safe_add_path_l(){
  26. test -d "$1" && PATH="$1:${PATH}"
  27. }
  28. __safe_add_path_l "$HOME/.local/bin"
  29. __safe_add_path_l "$HOME/.local/lib/gems/bin"
  30. __safe_add_path_r "/c/mingw/bin"
  31. __safe_add_path_r "/c/mingw/msys/1.0/bin"
  32. # macports coreutils
  33. # $isdarwin cannot be used it is not defined yet
  34. __safe_add_path_l "/opt/local/bin"
  35. __safe_add_path_l "/opt/local/sbin"
  36. __safe_add_path_l "/opt/local/libexec/gnubin"
  37. __safe_add_path_l \
  38. "/opt/local/Library/Frameworks/Python.framework/Versions/3.2/bin"
  39. test -f "${__dotdir}/rc.py" && export PYTHONSTARTUP="${__dotdir}/rc.py"
  40. test -d "$HOME/.local/lib/python/site-packages" && \
  41. export PYTHONPATH="${PYTHONPATH}:${HOME}/.local/lib/python/site-packages"
  42. export GEM_HOME="$HOME/.local/lib/gems"
  43. export RUBYLIB="$RUBYLIB:$HOME/.local/lib/gems/lib"
  44. # it is not so good
  45. # http://archive.linux.or.jp/JF/JFdocs/Program-Library-HOWTO/shared-libraries.html
  46. # http://superuser.com/questions/324613/installing-a-library-locally-in-home-directory-but-program-doesnt-recognize-it
  47. # without this ENV i cannot run tmux. another way is to use --disable-shared
  48. # when building tmux
  49. if ! __match "$LD_LIBRARY_PATH" "$HOME/.local/lib"
  50. then
  51. export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$HOME/.local/lib"
  52. fi
  53. # in my environment powerdown does not work
  54. test -z "$SSH_CONNECTION" && \
  55. type setterm >/dev/null 2>&1 && \
  56. setterm -blank 30 -powersave on # -powerdown 10
  57. #########################
  58. # shrc.common
  59. # this variable must consistent with setup.sh
  60. __shrc_common="$HOME/.shrc.common"
  61. if test -f "$__shrc_common"
  62. then
  63. . "$__shrc_common"
  64. else
  65. echo "$__shrc_common not found."
  66. echo "Run setup.sh first."
  67. return
  68. fi
  69. ##########################
  70. # system type
  71. gnu_coreutils=false # for mac
  72. null ls --version && gnu_coreutils=true
  73. inbash=false
  74. inzsh=false
  75. if test -n "$BASH_VERSION"
  76. then
  77. inbash=true
  78. elif test -n "$ZSH_VERSION"
  79. then
  80. inzsh=true
  81. fi
  82. #################################
  83. # file pathes:
  84. # shrc: Path to this file
  85. if $inbash
  86. then
  87. __shrc="$BASH_SOURCE"
  88. elif $inzsh
  89. then
  90. __shrc="$0"
  91. fi
  92. ##################################
  93. # EnvVal definitions
  94. export LANG=ja_JP.UTF-8
  95. export LC_MESSAGES=C
  96. export LC_TIME=C
  97. export TERMCAP="${TERMCAP}:vb="
  98. $ismsys && export HOSTNAME
  99. # export ENV=~/.shrc
  100. if false $iswindows
  101. then
  102. export PAGER='tr -d \\r | less'
  103. else
  104. export PAGER="less"
  105. fi
  106. export LESS="-iRMX"
  107. # Style for lesspipe is defined in esc.style
  108. _src_hilite_lp_path="`which src-hilite-lesspipe.sh 2>/dev/null`"
  109. for f in /usr/share/source-highlight/src-hilite-lesspipe.sh
  110. do
  111. test -z "$_src_hilite_lp_path" && test -e "$f" && _src_hilite_lp_path="$f"
  112. done
  113. test -n "$_src_hilite_lp_path" && export LESSOPEN="| $_src_hilite_lp_path %s"
  114. if null type vim
  115. then
  116. export EDITOR=vim
  117. else
  118. export EDITOR=vi
  119. fi
  120. # export CDPATH=".:~"
  121. export VISUAL="$EDITOR"
  122. export GIT_PAGER="less -FS"
  123. export GIT_EDITOR="$EDITOR"
  124. export GIT_MERGE_AUTOEDIT=no
  125. if test -n "$TMUX" && \
  126. __match $TERM screen && \
  127. __match `tmux display -p '#{client_termname}'` 256color
  128. then
  129. TERM=screen-256color
  130. fi
  131. if test -z "$TMP"
  132. then
  133. if test -n "$TMPDIR"
  134. then
  135. export TMP=$TMPDIR
  136. elif test -n "$TEMP"
  137. then
  138. export TMP="$TEMP"
  139. else
  140. export TMP=/tmp
  141. fi
  142. fi
  143. __match "$TMP" "${USER}-tmp" >/dev/null || export TMP="${TMP}/${USER}-tmp"
  144. export TEMP="$TMP"
  145. test -d "$TMP" || mkdir -p "$TMP"
  146. if ! $iswindows && null type stty
  147. then
  148. stty stop undef # unbind C-s to stop displaying output
  149. # stty erase '^h'
  150. fi
  151. if $iswindows
  152. then
  153. export USER=$USERNAME
  154. fi
  155. if test -d ~/dbx
  156. then
  157. export CHIT_PATH="$HOME/dbx/.chit"
  158. fi
  159. ##########################
  160. # Zsh specific preferences
  161. # http://www.clear-code.com/blog/2011/9/5.html
  162. if $inzsh
  163. then
  164. bindkey -e
  165. # http://zsh.sourceforge.net/Guide/zshguide06.html#l147
  166. autoload compinit; compinit
  167. # supress cycle by tab
  168. unsetopt auto_menu
  169. # unsetopt correct
  170. setopt complete_aliases
  171. setopt auto_list
  172. setopt bash_auto_list
  173. setopt magic_equal_subst
  174. setopt list_types
  175. # what is the difference of these two?
  176. setopt auto_param_slash
  177. setopt mark_dirs
  178. zstyle ':completion:*' list-colors ${(s.:.)LS_COLORS}
  179. zstyle ':completion:*' format '%B%d%b'
  180. zstyle ':completion:*' group-name ''
  181. zstyle ':completion:*' use-cache yes
  182. # zstyle ':completion:*:cd:*' tag-order local-directories
  183. zstyle ':completion:*' completer _complete _bash_completions \
  184. _history
  185. # zstyle ':completion:*:*:cd:*' completer
  186. zstyle ':completion:*' accept-exact-dirs true
  187. autoload colors; colors
  188. # autoload -Uz promptinit
  189. # promptinit
  190. # prompt walters
  191. setopt hist_ignore_dups
  192. setopt hist_ignore_all_dups
  193. setopt hist_save_no_dups
  194. setopt share_history
  195. setopt append_history
  196. setopt prompt_subst
  197. setopt interactive_comments
  198. fi
  199. ######################
  200. # Print welcome messages
  201. $iswindows && alias tty="echo cmd.exe"
  202. type fortune >/dev/null 2>&1 && {
  203. fortune
  204. echo
  205. fortune -o
  206. echo
  207. }
  208. uname -a
  209. echo TERM $TERM $(tput colors) colors connected to $(tty), \
  210. running $BASH $BASH_VERSION
  211. if test -n "$TMUX"
  212. then
  213. tmux display -p 'Using tmux #S:#I:#W.#P, client is #{client_termname}' \
  214. 2>/dev/null
  215. echo
  216. fi
  217. ###################################
  218. # some aliases and functions
  219. # __func_name: never used interactively
  220. # _func_name: usually not used interactively
  221. __safe_alias(){
  222. # __safe_alias <name>=<command>
  223. _bin=`expr "$1" : '^[^=]*=\([^ ]*\)'`
  224. test -n "$_bin" && \
  225. null type $_bin && \
  226. alias "$1"
  227. }
  228. $gnu_coreutils && _timeoption=" --time-style=long-iso"
  229. # color prefs
  230. if $gnu_coreutils
  231. then
  232. # http://qiita.com/yuyuchu3333/items/84fa4e051c3325098be3
  233. # gnu coreutils LS_COLORS is used
  234. null type dircolors && eval `dircolors`
  235. _coloroption=" --color=auto"
  236. else
  237. # export LSCOLORS=gxfxcxdxbxegedabagacad
  238. export LSCOLORS=DxGxcxdxCxegedabagacad
  239. export CLICOLOR=1
  240. fi
  241. alias ls="ls -hCF${_coloroption}${_timeoption}"
  242. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  243. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  244. _timeformat_num="%Y%m%d%H%M%S"
  245. alias datenum="date +$_timeformat_num"
  246. # export GREP_OPTIONS=""
  247. alias gr="grep -n --color=always"
  248. $iswindows && alias gr="grep -n"
  249. alias less="less -F"
  250. __safe_alias em="emacs -nw"
  251. __safe_alias vi=vim
  252. alias pstree="LANG=C pstree"
  253. alias cp="cp -v"
  254. alias mv="mv -v"
  255. alias rm="rm -v"
  256. alias psaux="ps auxww"
  257. alias q=exit
  258. __safe_alias e3=e3em
  259. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  260. alias po=popd
  261. alias pu=pushd
  262. __safe_alias sudo="sudo " # use aliases through sudo
  263. __safe_alias sudoe="sudoedit"
  264. # __safe_alias halt="sudo halt"
  265. # __safe_alias reboot="sudo reboot"
  266. null type dbus-send && {
  267. alias suspend="dbus-send --system --print-reply \
  268. --dest=org.freedesktop.UPower \
  269. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  270. alias hibernate="dbus-send --system --print-reply \
  271. --dest=org.freedesktop.UPower \
  272. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  273. }
  274. alias rand="echo \$RANDOM"
  275. __safe_alias xunp="file-roller -h"
  276. __safe_alias pc="sudo \paco -D"
  277. alias pycalc="python -i -c 'from math import *' "
  278. __safe_alias py3=python3
  279. __safe_alias py2=python2
  280. # Sometimes SHELL cannot be used. For example, when running bash inside zsh
  281. # SHELL is set to be /bin/zsh
  282. if $inbash
  283. then
  284. alias _reloadrc="exec bash"
  285. elif $inzsh
  286. then
  287. alias _reloadrc="exec zsh"
  288. else
  289. alias _reloadrc="exec $SHELL"
  290. fi
  291. # alias mytime="date +%Y%m%d-%H%M%S"
  292. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  293. # type trash >/dev/null 2>&1 && alias rm=trash
  294. __safe_alias mpg123="mpg123 -C -v --title"
  295. __safe_alias xm="xmms2"
  296. #export PLAYER="mpg123 -C -v --title"
  297. __safe_alias screen="screen -e^z^z"
  298. #alias zcd="cd \`zenity --file-selection --directory\`"
  299. __safe_alias gtags="gtags --verbose"
  300. __safe_alias htags="htags --xhtml --symbol --line-number \
  301. --frame --alphabet --verbose"
  302. __safe_alias au=aunpack
  303. __safe_alias lv="lv|less"
  304. __safe_alias rs="rsync --progress --itemize-changes --compress"
  305. if $iscygwin
  306. then
  307. __my_wget_options=" --no-check-certificate"
  308. __safe_alias wget="wget $__my_wget_options"
  309. fi
  310. if $isdarwin
  311. then
  312. alias updatedb="LC_ALL=C updatedb"
  313. # do not use locate installed by macports
  314. test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  315. fi
  316. # somehow not work
  317. # typeset -ga chpwd_functions
  318. # chpwd_functions+=pwd
  319. # chpwd(){
  320. # pwd
  321. # }
  322. cd(){
  323. builtin cd "$@"
  324. pwd
  325. }
  326. # pad
  327. alias pad=notepad
  328. __safe_alias pad=gedit
  329. __safe_alias pad=leafpad
  330. $isdarwin && alias pad="open -e"
  331. __safe_alias wic=wicd-curses
  332. __safe_alias wil="wicd-cli -y -l | head"
  333. #alias wicn="wicd-cli -y -c -n"
  334. wicn(){
  335. if test $# -eq 0
  336. then
  337. local num
  338. wicd-cli -y -l | head
  339. echo -n "input num: "
  340. read num
  341. test -n "$num" && wicd-cli -y -c -n $num
  342. else
  343. wicd-cli -y -c -n $1
  344. fi
  345. }
  346. __find_latest_vimdir(){
  347. vimdir=/usr/share/vim
  348. if test -d "$vimdir"
  349. then
  350. find "$vimdir" -name 'vim??' -type d | sort | tail -n 1
  351. else
  352. echo ""
  353. fi
  354. }
  355. for f in /usr/share/vim/vimcurrent "`__find_latest_vimdir`"
  356. do
  357. test -n "$f" || continue
  358. f="$f/macros/less.sh"
  359. test -f $f && alias vl=$f && break
  360. done
  361. alias pa=pacapt
  362. __safe_alias yt=yaourt
  363. __safe_alias cower="cower --color=auto"
  364. null type pacmatic && {
  365. alias pacman="pacmatic"
  366. export PACMAN="pacmatic"
  367. }
  368. __my_pacman_update_mirrorlist_with_reflector(){
  369. ml=/etc/pacman.d/mirrorlist
  370. cmd="$(expr "$(grep -m 1 reflector $ml)" : '# With: *\(.*\)')"
  371. if test -z "$cmd"
  372. then
  373. cmd="reflector --verbose -l 5 --sort rate --save $ml"
  374. fi
  375. echo "Running $cmd ..." 1>&2
  376. sudo $cmd
  377. }
  378. null type reflector && test -f /etc/pacman.d/mirrorlist && \
  379. alias reflect_mirrorlist=__my_pacman_update_mirrorlist_with_reflector
  380. null type apt-get && {
  381. alias aupgrade="sudo apt-get autoremove --yes && \
  382. sudo apt-get update --yes && sudo apt-get upgrade --yes"
  383. alias aptin="apt-get install"
  384. alias aptsearch="apt-cache search"
  385. alias aptshow="apt-cache show"
  386. }
  387. null type port && {
  388. alias port="port -v"
  389. alias pupgrade="sudo port -v selfupdate && \
  390. { sudo port -v upgrade outdated; }"
  391. }
  392. if $iscygwin
  393. then
  394. null type windate || \
  395. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  396. # alias cygsu="cygstart /cygwinsetup.exe"
  397. fi
  398. g(){
  399. if test $# -eq 0 && null type git-info
  400. then
  401. git info
  402. else
  403. git -c color.ui=always "$@"
  404. fi
  405. }
  406. if null type _git && $inbash
  407. then
  408. # enable programmable completion for g
  409. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  410. || complete -o default -o nospace -F _git g
  411. fi
  412. #git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  413. __safe_alias m=gitmemo
  414. alias setup.py3="sudo python3 setup.py install --record files.txt"
  415. randomstr(){
  416. len=$1
  417. test -z "$len" && len=8
  418. uuidgen | tr -d - | cut -c 1-len
  419. }
  420. datestr(){
  421. # datestr yyyyMMdd-hhmmss
  422. if test -z "$1" || test "$1" == "-h"
  423. then
  424. echo "datestr: usage: datestr <yyyyMMddhhmmss>"
  425. return 1
  426. fi
  427. dfmt= # actual format for date command
  428. while test -n "$1"
  429. do
  430. fmt="$1"
  431. while test -n "$fmt"
  432. do
  433. case "$fmt" in
  434. yyyy*) # year
  435. dfmt="${dfmt}%Y"
  436. fmt="`echo "$fmt" | cut -c 5-`"
  437. ;;
  438. yy*) # last two digits of year
  439. dfmt="${dfmt}%y"
  440. fmt="`echo "$fmt" | cut -c 3-`"
  441. ;;
  442. MM*) # month (01..12)
  443. dfmt="${dfmt}%m"
  444. fmt="`echo "$fmt" | cut -c 3-`"
  445. ;;
  446. dd*) # day of month (01..12)
  447. dfmt="${dfmt}%d"
  448. fmt="`echo "$fmt" | cut -c 3-`"
  449. ;;
  450. HH* | hh*) # hour (00..23)
  451. dfmt="${dfmt}%H"
  452. fmt="`echo "$fmt" | cut -c 3-`"
  453. ;;
  454. mm*) # minute (00..59)
  455. dfmt="${dfmt}%M"
  456. fmt="`echo "$fmt" | cut -c 3-`"
  457. ;;
  458. ss*) # second (00..60)
  459. dfmt="${dfmt}%S"
  460. fmt="`echo "$fmt" | cut -c 3-`"
  461. ;;
  462. *)
  463. char=`echo "$fmt" | cut -c 1`
  464. dfmt="${dfmt}${char}"
  465. fmt="`echo "$fmt" | cut -c 2-`"
  466. ;;
  467. esac
  468. done
  469. shift
  470. done
  471. date +"$dfmt"
  472. }
  473. # ssh(){
  474. # # __my_terminal_title ssh
  475. # command ssh "$@"
  476. # }
  477. __ssh_with_cd(){
  478. # __ssh_with_cd <host> <directory> [<arg> ...]
  479. if test -z "$2"
  480. then
  481. echo "usage: __ssh_with_cd <host> <directory> [<arg> ...]"
  482. return 1
  483. fi
  484. host="$1"
  485. shift
  486. dir="$1"
  487. shift
  488. ssh "$host" "$@" -t "cd \"$dir\"; \$SHELL -l"
  489. }
  490. memo(){
  491. if test -z "$1"
  492. then
  493. $EDITOR memo.txt
  494. else
  495. $EDITOR "$1/memo.txt"
  496. fi
  497. }
  498. now(){
  499. local tformat="%Y/%m/%d %H:%M:%S %z"
  500. cal
  501. REPLY=
  502. printf "\\r`date "+${tformat}"`"
  503. read -t 1
  504. while test $? -ne 0
  505. do
  506. printf "\\r`date "+${tformat}"`"
  507. read -t 1
  508. done
  509. }
  510. s(){
  511. if git rev-parse --git-dir >/dev/null 2>&1
  512. then
  513. echo ">> git grep -n $@" 1>&2
  514. git grep -n "$@"
  515. elif which ag >/dev/null 2>&1
  516. then
  517. echo ">> ag --pager=\"$PAGER\" $@" 1>&2
  518. ag --pager="$PAGER" "$@"
  519. elif which ack >/dev/null 2>&1
  520. then
  521. echo ">> ack --pager=\"$PAGER\" $@" 1>&2
  522. ack --pager="$PAGER" "$@"
  523. else
  524. echo \
  525. ">> find . " \
  526. "-path '*/.git' -prune -o" \
  527. "-path '*/.svn' -prune -o" \
  528. "-type f -exec grep -nH -e --color=always $@ {} +" 1>&2
  529. if test $# -eq 0
  530. then
  531. echo "No search word given." 1>&2
  532. return 1
  533. fi
  534. find . \
  535. -path '*/.git' -prune -o \
  536. -path '*/.svn' -prune -o \
  537. -type -f -exec grep -nH -e --color=always "$@" {} + \
  538. | $PAGER
  539. fi
  540. }
  541. if $inbash || $inzsh
  542. then
  543. man(){
  544. env \
  545. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  546. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  547. LESS_TERMCAP_me=$(printf "\e[0m") \
  548. LESS_TERMCAP_se=$(printf "\e[0m") \
  549. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  550. LESS_TERMCAP_ue=$(printf "\e[0m") \
  551. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  552. man "$@"
  553. }
  554. fi
  555. netwait(){
  556. while ! ping -c 1 -t 1 example.com
  557. do
  558. true
  559. done
  560. echo network works.
  561. }
  562. __realpath(){
  563. if type realpath >/dev/null 2>&1
  564. then
  565. command realpath "$@"
  566. else
  567. while ! test -d $1
  568. do
  569. shift
  570. done
  571. (command cd "$d" && echo "$PWD")
  572. # local d="$OLDPWD"
  573. # command cd "$1"
  574. # echo "$PWD"
  575. # command cd "$d"
  576. fi
  577. }
  578. tx(){
  579. if test $# -eq 0
  580. then
  581. echo ":: tx <session> to attach."
  582. tmux ls
  583. elif tmux has -t "$1"
  584. then
  585. tmux attach -t "$1"
  586. else
  587. tmux new -s "$1"
  588. fi
  589. }
  590. _tmux_prefs(){
  591. null type tmux || return 1
  592. tmux set -g mode-keys vi
  593. }
  594. dt(){
  595. # dt [<name>] [<command ...>]
  596. __dtach_dir="${TMP}/dtach"
  597. mkdir -p "${__dtach_dir}"
  598. if test -n "${__MY_DTACH}"
  599. then
  600. soc_name="`echo $__MY_DTACH | sed -e "s ^$__dtach_dir/ "`"
  601. echo "Current session: ${soc_name}"
  602. fi
  603. if test -z "$1"
  604. then
  605. echo "Sessions:"
  606. ls "${__dtach_dir}"
  607. return 0
  608. elif test "$1" = "-h"
  609. then
  610. echo "dt: usage: dt <name> [<command ...>]" 1>&2
  611. return 1
  612. fi
  613. soc_name="${__dtach_dir}/$1"
  614. shift
  615. if test -n "$__MY_DTACH"
  616. then
  617. echo "dtach session cannot be nested." 1>&2
  618. return 1
  619. elif test -S "$soc_name"
  620. then
  621. dtach -a "$soc_name" -e ^^
  622. elif test -e "$soc_name"
  623. then
  624. echo "dt: File named $soc_name already exists."
  625. return 1
  626. elif test -z "$1"
  627. then
  628. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ sh -c "$SHELL"
  629. # echo "dt: Socket named $soc_name not exists and no command specified."
  630. # return 1
  631. else
  632. __MY_DTACH="$soc_name" dtach -c "$soc_name" -e ^^ "$@"
  633. fi
  634. }
  635. scr(){
  636. test -n "$1" && pf="${1}-"
  637. local _tformat="%Y%m%d-%H%M%S%z"
  638. local _file="${HOME}/${pf}`date +${_tformat}`.script"
  639. __MY_SCRIPT=${_file} script ${_file} "$@"
  640. }
  641. dtscr(){
  642. # dtscr <command ...>
  643. if test -z "$1"
  644. then
  645. echo "dtscr: usage: dtscr <command ...>"
  646. return 1
  647. fi
  648. local _cmdstr="`echo $@ | tr ' ' +`"
  649. local _tformat="%Y%m%d-%H%M%S%z"
  650. local _name="${pf}`date +${_tformat}`-${_cmdstr}"
  651. local _scr_file="${HOME}/${_name}.script"
  652. local _dt_dir="${TMP}/dtscr"
  653. mkdir -p "$_dt_dir"
  654. dtach -n "${_dt_dir}/${_name}" script "${_scr_file_}" "$@"
  655. # echo $_name
  656. # echo $_file
  657. }
  658. mcrypt_stream(){
  659. test $# -eq 2 || return 1
  660. case $1 in
  661. en)
  662. mcrypt --key $2 | base64 ;;
  663. de)
  664. base64 -d | mcrypt -d --key $2 ;;
  665. esac
  666. }
  667. gpg_stream(){
  668. test $# -eq 2 || return 1
  669. case $1 in
  670. en)
  671. gpg --passphrase $2 -c --batch |base64 ;;
  672. de)
  673. base64 -d|gpg --passphrase $2 -d --batch ;;
  674. esac
  675. }
  676. dgpg(){
  677. if test "$1" = help || test -z "$2"
  678. then
  679. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  680. return
  681. fi
  682. local srcs="$2"
  683. local dsts="$3"
  684. test -z "$dsts" && dsts="${srcs}.out"
  685. local pw
  686. echo -n "dgpg pw: "
  687. read -s pw
  688. echo ""
  689. test -z "$pw" && return 1
  690. for f in *${srcs}
  691. do
  692. local d="$(basename "$f" "${srcs}")${dsts}"
  693. echo -n "Processing $f to $d..."
  694. if test -d "$f"
  695. then
  696. echo "`printf 'failed (%s is directory)' $f`"
  697. elif test -f "$d"
  698. then
  699. echo "`printf 'failed (%s is already exists)' $d`"
  700. elif <"$f" gpg_stream $1 $pw >"$d" 2>/dev/null
  701. then
  702. echo "done"
  703. else
  704. echo "failed"
  705. test -f "$d" && rm "$d"
  706. fi
  707. done
  708. }
  709. alias enst="gpg_stream en"
  710. alias dest="gpg_stream de"
  711. showinfo(){
  712. echo "Japanese letters are 表示可能"
  713. __safe_run diskinfo
  714. ! $isdarwin && test -n "${DISPLAY}" && {
  715. __safe_run xrandr | \grep --color=never ^Screen
  716. }
  717. $iswindows || __safe_run finger $USER
  718. LANG=C __safe_runc id
  719. __safe_run xset q
  720. }
  721. x(){
  722. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  723. #mkdir -p ~/.var/log
  724. # nohup startx >~/.var/log/xorg.log 2>&1 &
  725. # exit
  726. exec startx
  727. else
  728. echo "X cant be started! Another X is already running?" 1>&2
  729. fi
  730. }
  731. bak(){
  732. for file in "$@"
  733. do
  734. cp -v ${file} ${file}.bak
  735. done
  736. }
  737. di(){
  738. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  739. then
  740. local diffcmd=colordiff
  741. else
  742. local diffcmd=diff
  743. fi
  744. ${diffcmd} -u "$@" | ${PAGER}
  745. }
  746. tb(){
  747. __datenum=`date +%Y%m%d-%H%M%S`
  748. __tb="$HOME/.var/tb/$__datenum"
  749. mkdir -p "$__tb"
  750. for file in "$@"
  751. do
  752. mv -t "$__tb" "$file"
  753. done
  754. }
  755. mkcd(){
  756. if test -z "$1"
  757. then
  758. echo "mkcd: usage: mkcd <dir>"
  759. return 1
  760. elif test -d "$1"
  761. then
  762. echo "Dir \"$1\" already exists."
  763. else
  764. mkdir -p "$1"
  765. echo "Dir \"$1\" created."
  766. fi
  767. cd "$1"
  768. }
  769. mkcdd(){
  770. # make and change date directory
  771. _d=`date +%Y%m%d-%H%M%S`
  772. mkcd "$_d"
  773. }
  774. if test -n "$TMUX" && null type reattach-to-user-namespace
  775. then
  776. alias pbpaste="reattach-to-user-namespace pbpaste"
  777. alias pbcopy="reattach-to-user-namespace pbcopy"
  778. fi
  779. catclip(){
  780. if $iswindows
  781. then
  782. cat /dev/clipboard | tr -d \\r
  783. elif $isdarwin
  784. then
  785. pbpaste
  786. else
  787. xclip -o -selection "clipboard"
  788. fi
  789. }
  790. setclip(){
  791. if test $# -eq 0
  792. then
  793. exec 3<&0
  794. else
  795. exec 3<<__EOF__
  796. `cat "$@"`
  797. __EOF__
  798. fi
  799. if $iswindows
  800. then
  801. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  802. elif $isdarwin
  803. then
  804. pbcopy 0<&3
  805. else
  806. 0<&3 xclip -i -f -selection "primary" | \
  807. xclip -i -f -selection "clipboard"
  808. fi
  809. exec 3<&-
  810. }
  811. open_file(){
  812. if $iscygwin
  813. then
  814. cygstart "$@"
  815. elif $ismsys
  816. then
  817. cmd.exe //c start "" "$@"
  818. elif $isdarwin
  819. then
  820. touch "$@"
  821. open "$@"
  822. elif $islinux
  823. then
  824. touch "$@"
  825. if null type pcmanfm; then
  826. LC_MESSAGES= pcmanfm "$@"
  827. else
  828. LC_MESSAGES= xdg-open "$@" &
  829. fi
  830. else
  831. cat "$@"
  832. fi
  833. }
  834. o(){
  835. if test $# -eq 0
  836. then
  837. open_file .
  838. else
  839. for f in "$@"
  840. do
  841. open_file "$(realpath "$f")"
  842. done
  843. fi
  844. }
  845. convmv_sjis2utf8_test(){
  846. convmv -r -f sjis -t utf8 *
  847. }
  848. convmv_sjis2utf8_notest(){
  849. convmv -r -f sjis -t utf8 * --notest
  850. }
  851. #################################################
  852. ## pastebin services
  853. ## https://wiki.archlinux.org/index.php/List_of_Applications/Internet#Pastebin_clients
  854. sprunge(){
  855. # http://sprunge.us
  856. if test -z "$1"
  857. then
  858. curl -F 'sprunge=<-' http://sprunge.us
  859. else
  860. curl http://sprunge.us/$1
  861. fi
  862. }
  863. dpaste(){
  864. # http://dpaste.de
  865. if test -z "$1"
  866. then
  867. curl -F 'content=<-' https://dpaste.de/api/
  868. echo
  869. else
  870. curl https://dpaste.de/$1/raw/
  871. fi
  872. }
  873. ######################################
  874. ## Prompt Settings
  875. __my_moc_state(){
  876. type mocp >/dev/null 2>&1 || return
  877. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  878. printf "$1" "`mocp -Q %title 2>/dev/null`"
  879. }
  880. __my_parse_svn_branch() {
  881. local LANG=C
  882. local svn_url=$(svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  883. local svn_repository_root=$(svn info 2>/dev/null | \
  884. sed -ne 's#^Repository Root: ##p')
  885. echo ${svn_url} | sed -e 's#^'"${svn_repository_root}"'##g' | \
  886. awk '{print $1}'
  887. }
  888. __my_svn_ps1(){
  889. if svn status >/dev/null 2>&1
  890. then
  891. local svn_branch=$(__my_parse_svn_branch)
  892. test -n "${svn_branch}" && printf "$1" "{$svn_branch}"
  893. fi
  894. }
  895. __my_battery_status(){
  896. local dir=/sys/class/power_supply/BAT0
  897. if test -d $dir && test -r $dir/status && test -r $dir/charge_full && \
  898. test -r $dir/charge_now
  899. then
  900. local st=$(cat $dir/status)
  901. local full=$(cat $dir/charge_full)
  902. local now=$(cat $dir/charge_now)
  903. local rate=$(expr $now \* 100 / $full)
  904. printf "$1" "${st}:${rate}%"
  905. fi
  906. }
  907. alias bat='__my_battery_status %s\\n'
  908. ipaddress(){
  909. # ipaddress <fmt>
  910. type ip >/dev/null 2>&1 || return 1
  911. local ip=$(LANG=C ip addr show scope global | \
  912. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  913. test -n "$ip" && printf $1 $ip
  914. }
  915. __my_ps1_str=""
  916. test -n "$__MY_SCRIPT" && \
  917. __my_ps1_str="${__my_ps1_str}${__my_c5}SCR${__my_cdef} "
  918. test -n "$SSH_CONNECTION" && \
  919. __my_ps1_str="${__my_ps1_str}${__my_c5}SSH${__my_cdef} "
  920. test -n "$__MY_DTACH" && \
  921. __my_ps1_str="${__my_ps1_str}${__my_c5}DTACH${__my_cdef} "
  922. __my_ps1_scale(){
  923. if null type stty && ! $ismsys
  924. then
  925. echo "[LxC:`stty size | tr -d $'\n' | tr " " x`]"
  926. fi
  927. }
  928. __my_ps1_tmux(){
  929. null type tmux || return $last
  930. local tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  931. test -n "$TMUX" && echo "[TMUX:$tmuxc]"
  932. }
  933. __my_ps1_moc(){
  934. __my_moc_state "[MOC:%s]"
  935. }
  936. for f in /usr/share/git/git-prompt.sh \
  937. /etc/bash_completion.d/git-prompt \
  938. /opt/local/share/git-core/git-prompt.sh \
  939. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  940. do
  941. test -r "$f" && ($inbash || $inzsh) && . "$f" && break
  942. done
  943. GIT_PS1_SHOWDIRTYSTATE=t
  944. GIT_PS1_SHOWUPSTREAM=t
  945. __my_ps1_git(){
  946. null type __git_ps1 || return $last
  947. null git rev-parse --git-dir >/dev/null 2>&1 || return $last
  948. __git_ps1 "[GIT:$(__safe_run git config --get user.name):%s]"
  949. }
  950. __my_ps1_ipaddr(){
  951. ! $iswindows && ipaddress '[Addr:%s]'
  952. }
  953. __my_ps1_bttry(){
  954. local bst="${TMP}/batterystatus"
  955. if test -z "$DISPLAY" && ! $iswindows
  956. then
  957. test -f $bst && local bstr="$(cat $bst)"
  958. test -n "$bstr" && ! echo $bstr | grep 100 >/dev/null 2>&1 && \
  959. echo "[Battery:$bstr]"
  960. __my_battery_status %s >$bst &
  961. fi
  962. }
  963. __my_ps1_dirs(){
  964. dirs | wc -l
  965. }
  966. __my_ps1_jobs(){
  967. # __my_ps1_jobs [<num>]
  968. if test -n "$1"
  969. then
  970. jobs="$1"
  971. else
  972. jobs="`jobs | wc -l`"
  973. fi
  974. if test "$jobs" -gt 0
  975. then
  976. echo "[JOBS:$jobs] "
  977. fi
  978. }
  979. __my_alert_fail(){
  980. test $laststatus -eq 0 || \
  981. echo "[STATUS:${laststatus}] "
  982. }
  983. # About ansi escape sequences
  984. # http://archive.linux.or.jp/JF/JFdocs/Bash-Prompt-HOWTO-5.html
  985. # http://www.grapecity.com/japan/powernews/column/clang/047/page02.htm
  986. if $inbash || $inzsh
  987. then
  988. if $inzsh
  989. then
  990. __attr_beg=$'%{\033['
  991. __attr_end='m%}'
  992. else
  993. __attr_beg='\[\033['
  994. __attr_end='m\]'
  995. fi
  996. __color_default="${__attr_beg}0${__attr_end}"
  997. __color_black="${__attr_beg}0;30${__attr_end}"
  998. __color_red="${__attr_beg}0;31${__attr_end}"
  999. __color_green="${__attr_beg}0;32${__attr_end}"
  1000. __color_brown="${__attr_beg}0;33${__attr_end}"
  1001. __color_blue="${__attr_beg}0;34${__attr_end}"
  1002. __color_purple="${__attr_beg}0;35${__attr_end}"
  1003. __color_cyan="${__attr_beg}0;36${__attr_end}"
  1004. __color_light_gray="${__attr_beg}0;37${__attr_end}"
  1005. __color_dark_gray="${__attr_beg}1;30${__attr_end}"
  1006. __color_light_red="${__attr_beg}1;31${__attr_end}"
  1007. __color_light_green="${__attr_beg}1;32${__attr_end}"
  1008. __color_yellow="${__attr_beg}1;33${__attr_end}"
  1009. __color_light_blue="${__attr_beg}1;34${__attr_end}"
  1010. __color_light_purple="${__attr_beg}1;35${__attr_end}"
  1011. __color_light_cyan="${__attr_beg}1;36${__attr_end}"
  1012. __color_white="${__attr_beg}1;37${__attr_end}"
  1013. __color_bg_black="${__attr_beg}40${__attr_end}"
  1014. __color_bg_red="${__attr_beg}41${__attr_end}"
  1015. __color_bg_green="${__attr_beg}42${__attr_end}"
  1016. __color_bg_brown="${__attr_beg}43${__attr_end}"
  1017. __color_bg_blue="${__attr_beg}44${__attr_end}"
  1018. __color_bg_purple="${__attr_beg}45${__attr_end}"
  1019. __color_bg_cyan="${__attr_beg}46${__attr_end}"
  1020. __color_bg_light_gray="${__attr_beg}47${__attr_end}"
  1021. __attr_underline="${__attr_beg}4${__attr_end}"
  1022. __attr_reverse="${__attr_beg}7${__attr_end}"
  1023. __attr_bold="${__attr_beg}1${__attr_end}"
  1024. fi
  1025. # NOTE: tput is another easy way to set colors and background
  1026. # For example, "$(tput setab 4)text$(tput sgr0)" print text with background
  1027. # color blue.
  1028. # http://www.ibm.com/developerworks/jp/linux/aix/library/au-learningtput/index.html
  1029. if test "$TERM" != dumb
  1030. then
  1031. __my_c1="$__attr_bold$__attr_underline" # color for PWD
  1032. __my_c2="$__attr_bold$__attr_underline" # color for user and hostname
  1033. # color for ::
  1034. case "`hostname`" in
  1035. arch-aspireone)
  1036. __my_c4="$__color_light_blue"
  1037. ;;
  1038. darwin-mba.local)
  1039. __my_c4="$__color_light_cyan"
  1040. ;;
  1041. newkiwi)
  1042. __my_c4="$__color_light_purple"
  1043. ;;
  1044. *)
  1045. __my_c4="$__color_light_green"
  1046. ;;
  1047. esac
  1048. __my_c5="$__color_black$__color_bg_light_gray" # color for SCR
  1049. __my_cdef="$__color_default"
  1050. fi
  1051. if $inbash
  1052. then
  1053. __my_ps1_sh="[BASH:$BASH_VERSION]"
  1054. elif $inzsh
  1055. then
  1056. __my_ps1_sh="[ZSH:$ZSH_VERSION]"
  1057. fi
  1058. __my_ps1_info(){
  1059. echo "${__my_ps1_sh}$(__my_ps1_scale)$(__my_ps1_git)$(__my_ps1_bttry)$(__my_ps1_ipaddr)$(__my_ps1_moc)"
  1060. }
  1061. __my_ps1_save_pos="\[\033[s\]"
  1062. __my_ps1_restore_pos="\[\033[u\]"
  1063. __my_ps1_move_rightmost="\[\033[\$(tput cols)C\]"
  1064. __my_ps1_move_15left="\[\033[15D\]"
  1065. # collapse when command line is too long and try to write over this string
  1066. # __my_ps1_right="${__my_ps1_save_pos}${__my_ps1_move_rightmost}"
  1067. # ${__my_ps1_move_15left}\D{%Y/%m/%d %H:%M}${__my_ps1_restore_pos}
  1068. if $inzsh
  1069. then
  1070. PROMPT="\
  1071. ${__my_c4}:: ${__my_cdef}[${__my_c2}%n@%M${__my_cdef}:${__my_c1}%~/${__my_cdef}]\$(__my_ps1_info)
  1072. ${__my_c4}:: ${__my_cdef}\$(__my_ps1_jobs)${__my_ps1_str}\$(__my_alert_fail)%# "
  1073. RPROMPT="%D{%Y/%m/%d %H:%M}"
  1074. elif $inbash
  1075. then
  1076. PS1="\
  1077. ${__my_c4}:: ${__my_cdef}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_info)\n\
  1078. ${__my_c4}:: ${__my_cdef}\D{%Y/%m/%d %H:%M} \$(__my_ps1_jobs \j)${__my_ps1_str}\$(__my_alert_fail)${__my_ps1_right}\$ "
  1079. else
  1080. true
  1081. # PS1="$(printf $(whoami)@$(hostname)$ )"
  1082. fi
  1083. __my_set_header_line(){
  1084. # save current position
  1085. printf "\033[s"
  1086. # move to 0,0
  1087. printf "\033[0;0H"
  1088. # clear curent to eol
  1089. printf "\033[K"
  1090. printf "\033[7m"
  1091. printf "$1"
  1092. printf "\033[0m"
  1093. # restore saved position
  1094. printf "\033[u"
  1095. }
  1096. __my_set_screen_name(){
  1097. # set window name
  1098. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  1099. then
  1100. echo -ne "\033k$1\033\\"
  1101. fi
  1102. }
  1103. __my_set_title(){
  1104. case $TERM in
  1105. (rxvt*|xterm*|aterm|screen*)
  1106. test -t 1 &&
  1107. test -z "$EMACS" &&
  1108. echo -n -e "\033]0;$1\007"
  1109. ;;
  1110. esac
  1111. }
  1112. if test -n "$TMUX"
  1113. then
  1114. __terminal_title="\$(basename \${PWD})"
  1115. else
  1116. if test -n "$SSH_CONNECTION" && expr "$TERM" : '^screen'
  1117. then
  1118. __terminal_title="`whoami`@`hostname`:\$(basename \${PWD})"
  1119. else
  1120. __terminal_title="`whoami`@`hostname`:\${PWD}"
  1121. fi
  1122. fi
  1123. if $inzsh
  1124. then
  1125. precmd(){
  1126. laststatus=$?
  1127. eval __my_set_title ${__terminal_title}
  1128. }
  1129. else
  1130. PROMPT_COMMAND="laststatus=\$?;__my_set_title \"${__terminal_title}\";$PROMPT_COMMAND"
  1131. fi
  1132. laststatus=0